<template>
  <div :class="['live-casino-module-3 px-2 sm:px-0', deviceTemplate]">
    <div class="sm:h-[52px] mb-2 sm:mb-4 flex gap-2">
      <div class="flex-grow">
        <div
          :class="[
            'flex items-center whitespace-nowrap ml-0 primary w-full',
            deviceTemplate === 'mobile' ? 'gap-1' : 'gap-2',
          ]"
        >
          <div class="text-sm sm:text-2xl font-bold uppercase">
            {{ $t("live_casino") }}
          </div>
          <el-divider class="primary" />
        </div>
        <div
          :class="[
            'font-medium uppercase text-[var(--text2)]',
            deviceTemplate === 'mobile' ? 'text-xs' : 'text-sm',
          ]"
        >
          {{ $t("Best Online Live Casino Betting") }}
        </div>
      </div>
      <div
        class="hidden xl:hidden md:flex flex-nowrap items-center justify-center gap-2"
      >
        <button @click="scrollDisplayCard(false)">
          <SvgIcon
            svg-name="icon-arrow-left"
            class="w-6 h-6"
            :class="{ 'primary-fill': isBackwardable }"
          />
        </button>
        <button @click="scrollDisplayCard(true)">
          <SvgIcon
            svg-name="icon-arrow-right"
            class="w-6 h-6"
            :class="{ 'primary-fill': isFowardable }"
          />
        </button>
      </div>
    </div>
    <el-scrollbar
      id="live-casino-three-scrollbar"
      @scroll="checkAvailableScroll"
    >
      <div
        id="scrollbar-child"
        :class="[
          'flex flex-nowrap xl:grid xl:grid-cols-2',
          deviceTemplate === 'mobile' ? 'gap-2' : 'gap-4',
        ]"
      >
        <div v-for="(item, index) in playableGame" :key="index">
          <div
            class="module-three-display-card flex-shrink-0 w-[200px] h-[100px] md:w-[592px] md:h-[unset] xl:w-[unset] xl:flex-shrink bg-background3 rounded-lg cursor-pointer md:cursor-default"
            @click="redirectPage(`/game/${item.GameId}`)"
          >
            <div class="h-[100px] md:h-[192px] w-full relative">
              <img
                class="casino-module-2-background"
                :src="getAssetImage('assets/modules/live-casino/03/bg.png')"
              />
              <img
                class="animated-gif"
                :src="
                  getAssetImage('assets/modules/live-casino/03/animated.gif')
                "
              />
              <div class="relative flex justify-between h-full items-center">
                <div>
                  <img
                    class="absolute bottom-0 star-background transition-[height] duration-500"
                    :src="
                      getAssetImage('assets/modules/live-casino/03/deco.png')
                    "
                  />
                  <img
                    class="absolute star-image transition-[height, margin] duration-500"
                    :src="
                      getAssetImage(
                        `assets/theme/common/entry/live_casino/${item.GameProviderName.replaceAll(
                          ' ',
                          ''
                        )}/star.png`
                      )
                    "
                  />
                </div>
                <div class="h-full md:h-unset">
                  <div
                    class="flex justify-center m-3 md:w-[188px] flex-wrap items-center md:m-6"
                  >
                    <div class="h-14 md:w-[140px]">
                      <img
                        class="w-20 md:w-full h-full object-contain my-auto"
                        :src="item.ProviderLogoCenterPath"
                        alt=""
                      />
                    </div>
                    <div
                      class="w-full text-center font-bold text-sm mt-2 mb-6 uppercase text-[var(--text3)] hidden md:block"
                    >
                      {{ item.GameName }}
                    </div>
                    <nuxt-link
                      class="hidden md:inline-block"
                      :to="!authenticated ? '/login' : `/game/${item.GameId}`"
                    >
                      <el-button
                        type="primary"
                        class="capitalize active:bg-red-50"
                        round
                        >{{ $t("play_now").toLowerCase() }}</el-button
                      >
                    </nuxt-link>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div
            class="w-full text-left text-xs mt-1 sm:text-sm sm:mt-2 sm:mb-6 uppercase text-[var(--text2)] block md:hidden font-medium"
          >
            {{ item.GameName }}
          </div>
        </div>
      </div>
    </el-scrollbar>
  </div>
</template>

<script lang="ts" setup>
import { defineProps } from "vue";
import { ILobbySettingsText } from "~~/models/customizeTheme";
import commonHelper from "@/utils/commonHelper";
import useLiveCasinoModule from "@/composables/lobby/useLiveCasinoModule";

const props = defineProps<{
  data: ILobbySettingsText;
}>();
const deviceTemplate = useDevice().isDesktop ? "desktop" : "mobile";
const { getAssetImage } = commonHelper;
const { playableGame, redirectPage, authenticated } = useLiveCasinoModule(
  props.data
);

const isFowardable = ref(true);
const isBackwardable = ref(false);

const checkAvailableScroll = () => {
  const displayCard = document.getElementById("live-casino-three-scrollbar");
  const cardScroller = displayCard?.querySelector(".el-scrollbar__wrap");
  const remainingScroll = Math.floor(
    cardScroller.scrollWidth -
      cardScroller.clientWidth -
      cardScroller.scrollLeft
  );
  isFowardable.value = remainingScroll > 0;
  isBackwardable.value = cardScroller?.scrollLeft > 0;
};

const scrollDisplayCard = (isForward: boolean) => {
  const displayCard = document.getElementById("live-casino-three-scrollbar");
  const cardScroller = displayCard?.querySelector(".el-scrollbar__wrap");
  const scrollbarChild =
    displayCard?.ownerDocument.getElementById("scrollbar-child");
  const scrollAmount =
    (scrollbarChild?.querySelector(".module-three-display-card")?.clientWidth +
      16) *
    (isForward ? 1 : -1);
  cardScroller?.scrollBy({
    left: scrollAmount,
    behavior: "smooth",
  });
};
</script>
<style lang="scss">
.live-casino-module-3 {
  &.mobile {
    .el-divider--horizontal {
      border-top: solid 1px var(--primary);
    }
  }

  .primary {
    color: var(--primary);
  }
  .el-divider--horizontal {
    border-top: solid 2px var(--primary);
    margin: 0 !important;
  }
  .casino-module-2-background {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 192px;
    opacity: 30%;
  }
  .animated-gif {
    background-size: cover;
    position: absolute;
    display: none;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    mix-blend-mode: screen;
    &:hover {
      display: unset;
    }
  }
  #live-casino-three-scrollbar {
    > .el-scrollbar__wrap {
      scroll-snap-type: x mandatory;
    }
    #scrollbar-child > * {
      scroll-snap-align: start;
    }
  }
  .module-three-display-card {
    overflow: hidden;
    .star-background {
      width: 141px;
      height: 91px;
    }
    .star-image {
      height: 95px;
      margin-bottom: -10px;
      top: 14px;
      left: -10px;
    }
  }
  .primary-fill {
    fill: var(--primary);
  }
  .el-button.el-button--primary {
    transition: background-color 1000ms;
  }
  .el-button.el-button--primary:focus {
    --D500: linear-gradient(0deg, var(--tertiary), var(--tertiary)),
      linear-gradient(0deg, rgba(23, 23, 23, 0.5), rgba(23, 23, 23, 0.5));
    border: none;
    transition: background-color 100ms;
    background: var(--D500) !important;
  }
}

@media (min-width: 768px) {
  .live-casino-module-3 {
    .module-three-display-card {
      overflow: hidden;
      .star-background {
        width: unset;
        height: 190px;
      }
      .star-image {
        height: 185px;
      }
    }
    .module-three-display-card:hover {
      .animated-gif {
        display: unset;
      }
      .star-background {
        height: 165px;
      }
      .star-image {
        height: 275px;
        top: -25px;
      }
    }
  }
}
</style>
